import 'package:flutter/widgets.dart';

class KeepStateWidget extends StatefulWidget {
  final Widget child;
  final bool keep;

  KeepStateWidget({Key? key, required this.child, this.keep = true}) : super(key: key);

  @override
  _KeepStateWidgetState createState() {
    return _KeepStateWidgetState();
  }
}

class _KeepStateWidgetState extends State<KeepStateWidget>
    with AutomaticKeepAliveClientMixin {
  @override
  bool get wantKeepAlive => widget.keep;

  @override
  Widget build(BuildContext context) {
    super.build(context);
    return widget.child;
  }
}
